#########################
# Area::Structure::Hall #
#########################

package Roguelike::Area::Structure::Hall;

use strict;
use warnings;
use Roguelike::Game;
use Roguelike::Utility;

use Roguelike::Tilemap;
use Roguelike::Area;

use Exporter ();
our @ISA = ("Exporter");
our @EXPORT = do {
  no strict "refs";
  grep defined &$_, keys %{ __PACKAGE__ . "::" };
};

sub new {
  shift;  # Who cares?
  my $map;
  my $mode;
  $mode = shift if $_[0] eq "/" or $_[0] eq "\\" or $_[0] eq "h";
  $mode ||= "H";
  if ($mode eq "h" or ($mode eq "H" and percent(50))) {
    my $height = shift;
    my $width = shift;
    # Deal with the offset bug LATER.
    $map = new Roguelike::Tilemap $height, $width, ".";
    $map->border;
    $map->{Exits} = findwalls($map, 1, 1, 1, 1);
    $map->{Exits}{Type} = "Room";
    # Set map data here
    $map->{Map}[ random(1, $height - 1)][ random(1, $width - 1) ]{_} = "+" if percent(5);
    for (1 .. 5) {
      my ($y, $x) = ( random(1, $height - 1), random(1, $width - 1) );
      push @{ $map->{Exits}{Hotspots} }, [$y, $x] if $map->{Map}[$y][$x]{_} eq ".";
    }
    return $map;
  } else {
    #my $height = shift;
    #my $width = shift;
    my $height = 11;
    my $width = 13;
    # 11, 13, remember guys
    $map = new Roguelike::Tilemap $height, $width, " ";
    if ($mode eq "\\" or ($mode eq "H" and percent(50))) {
      # \
      foreach my $y (0 .. $height - 1) {
        foreach my $x (0 .. $width - 8) {
          next if $y == 0 and $x == 0;
          next if $y == $height - 1 and $x == $width - 8;
          $map->{Map}[$y][$x + $y - 1]{_} = ".";
        }
      }
    } else {
      # /
      foreach my $y (0 .. $height - 1) {
        foreach my $x (0 .. $width - 8) {
          next if $y == 0 and $x == 0;
          next if $y == $height - 1 and $x == $width - 8;
          $map->{Map}[$y][-1 * ($x + $y)]{_} = ".";
        }
      }
    }
    $map->border;
    $map->{Exits} = findwalls($map, 1, 1, 2, 2);
    $map->{Exits}{Type} = "Hall";
    for (1 .. 5) {
      my ($y, $x) = ( random(0, $map->height), random(0, $map->width) );
      push @{ $map->{Exits}{Hotspots} }, [$y, $x] if $map->{Map}[$y][$x]{_} eq ".";
    }
  }
  return $map;
}

42;
