##############
# Area::Test #
##############

package Roguelike::Area::Test;

use strict;
use warnings;
use Roguelike::Game;
use Roguelike::Utility;

use Roguelike::Tilemap;
use Roguelike::Area;
use Roguelike::Area::Structure::Hall;

sub generate {
  shift;  # We aren't really a class, no are we?
  my ($height, $width, $depth) = @_;
  my $map = new Roguelike::Tilemap $height, $width, ".";
  $map->border;
  $map->fill([1, 1], [$height - 1, $width - 1], " ");
  # Place cool diagonal things.
  place(
    Roguelike::Area::Structure::Hall->new("/", 11, 13),
    on => $map,
    at => [2, 3],
  );
  # Now the second one.
  &connect(
    Roguelike::Area::Structure::Hall->new("\\", 11, 13),
    on => $map,
    to => 0,
    wall => 0,
    dir => "E"
  );
  # Below first.
  &connect(
    Roguelike::Area::Structure::Hall->new("\\", 11, 13),
    on => $map,
    to => 0,
    wall => 0,
    dir => "S"
  );
  # Last one!!!
  &connect(
    Roguelike::Area::Structure::Hall->new("/", 11, 13),
    on => $map,
    to => 2,
    wall => 0,
    dir => "E"
  );
  # Carve.
  clearout(
    on => $map,
    between => [[1, 0], [3, 0]],
    dir => "S"
  );
  $_->{Hotspots} = [] foreach @{ $map->{Exits} };
  foreach (1 .. 10) { # Zzz
    while (1) {
      my $y = random(1, $height);
      my $x = random(1, $width);
      next unless $map->{Map}[$y][$x]{_} eq ".";
      next if $map->{Map}[$y][$x]{Hotspot};
      $map->{Map}[$y][$x]{Hotspot} = 1;
      push @{ $map->{Exits}[0]{Hotspots} }, [$y, $x];
      last;
    }
  }
  $map->refresh;
  return $map;
}

42;
